#include "cdictionaryinttoint.h"
#include <iostream>
CDictionaryIntToInt::CDictionaryIntToInt(){};
int CDictionaryIntToInt::find(int key) const{return this->key.find(key);}
int CDictionaryIntToInt::get(int key)const{return this->val.get(find(key));}
bool CDictionaryIntToInt::add(int key,int val, bool force){if(!force && find(key)!=-1)return 0;this->key.append(key);this->val.append(val);total++;return 1;}
CDictionaryIntToInt::CDictionaryIntToInt(int key,int val) {this->add(key,val);}
bool CDictionaryIntToInt::remove(int key){key=this->find(key);if (key==-1)return 0;total--;this->key.remove(key);this->val.remove(key);return 1;};
void CDictionaryIntToInt::removepos(int pos){total--;this->key.remove(pos);this->val.remove(pos);};
CDictionaryIntToInt::CDictionaryIntToInt(CDictionaryIntToInt&& other)noexcept{*this=other;other.~CDictionaryIntToInt();other.total=0;}
CDictionaryIntToInt::CDictionaryIntToInt(const CDictionaryIntToInt& other){
    for(int i=0;i<other.total;i++) {
    this->add(other.key.get(i),other.val.get(i),1);}
}
int CDictionaryIntToInt::gettotal()const{return total;}
CDictionaryIntToInt CDictionaryIntToInt::operator+(const CDictionaryIntToInt& other)const{
    if (total==0)
        return other;
    CDictionaryIntToInt returnme(other);
    for (int i=0;i<total;i++){
        int key=this->key.get(i);
        if (other.find(key)==-1)returnme.add(key,this->val.get(i));
    }
    return returnme;
}
CDictionaryIntToInt CDictionaryIntToInt::operator-(const CDictionaryIntToInt& other)const{
    CDictionaryIntToInt returnme(*this);
    for (int i=0;i<returnme.total;i++)
        if (other.find(returnme.key.get(i))!=-1){returnme.removepos(i);i--;}
    return returnme;
}
CDictionaryIntToInt& CDictionaryIntToInt::operator=(const CDictionaryIntToInt& other) {if (this==&other)return *this;
    key.~OnewayList();val.~OnewayList();total=0;
    for (int i = 0; i < other.total; i++) {
        this->add(other.key.get(i), other.val.get(i), true);
    }
    return *this;
}
// CDictionaryIntToInt CDictionaryIntToInt::operator/(const CDictionaryIntToInt& other)const{
//     CDictionaryIntToInt returnme(*this);//значення з першого
//     for (int i=0;i<returnme.total;i++)
//         if (other.find(returnme.key.get(i))==-1){returnme.removepos(i);i--;}
//     return returnme;
// }
bool CDictionaryIntToInt::operator==(const CDictionaryIntToInt& other)const{
    if (this==&other)return true;
    if (total!=other.total)return false;
    for (int i=0;i<total;i++)
        if(other.get(this->key.get(i))!=this->val.get(i))return false;return true;}
CDictionaryIntToInt CDictionaryIntToInt::operator/(const CDictionaryIntToInt& other)const{
    CDictionaryIntToInt returnme;
    for (int i=0;i<total;i++){
        int otherkey=other.key.find(key.get(i));
        if (otherkey==-1)continue;
        if(other.val.get(otherkey)==val.get(i))returnme.add(key.get(i),val.get(i),true);}
    return returnme;}
std::istream& operator>>(std::istream& in, CDictionaryIntToInt& dict) {
    int key, value;
    while (in>>key){
        if (!(in>>value)) {
            std::cerr<<"Warning: Incomplete pair was entered. Ignoring "<<key<<'.'<<std::endl;
            break;
        }
        if(!dict.add(key, value))std::cerr<<"Warning: key \""<<key<<"\" was input before. Ignoring..."<<std::endl;
    }
    return in;
}
std::ostream& operator<<(std::ostream& out, const CDictionaryIntToInt& dict) {
    for (int i=0;i<dict.total;i++)out<<dict.key.get(i)<<"->"<<dict.val.get(i)<<std::endl;
    return out;
}
